JUCE: ARAOutputStream Class Reference

JUCE

Public Member Functions | List of all members
ARAOutputStream Class Reference
juce_audio_processors » utilities

Used to write persistent ARA archives - see doStoreObjectsToStream() for details. More...

`#include <juce_ARADocumentController.h>`

Inheritance diagram for ARAOutputStream:

## Public Member Functions
| ARAOutputStream (ARA::PlugIn::HostArchiveWriter *)
int64 | getPosition () override
| Returns the stream's current position. More...
void | flush () override
| If the stream is using a buffer, this will ensure it gets written out to the destination. More...
bool | write (const void *, size_t) override
| Writes a block of data to the stream. More...
bool | setPosition (int64) override
| Tries to move the stream's output position. More...
Public Member Functions inherited from OutputStream
virtual | ~OutputStream ()
| Destructor. More...
virtual void | flush ()=0
| If the stream is using a buffer, this will ensure it gets written out to the destination. More...
virtual bool | setPosition (int64 newPosition)=0
| Tries to move the stream's output position. More...
virtual int64 | getPosition ()=0
| Returns the stream's current position. More...
virtual bool | write (const void *dataToWrite, size_t numberOfBytes)=0
| Writes a block of data to the stream. More...
virtual bool | writeByte (char byte)
| Writes a single byte to the stream. More...
virtual bool | writeBool (bool boolValue)
| Writes a boolean to the stream as a single byte. More...
virtual bool | writeShort (short value)
| Writes a 16-bit integer to the stream in a little-endian byte order. More...
virtual bool | writeShortBigEndian (short value)
| Writes a 16-bit integer to the stream in a big-endian byte order. More...
virtual bool | writeInt (int value)
| Writes a 32-bit integer to the stream in a little-endian byte order. More...
virtual bool | writeIntBigEndian (int value)
| Writes a 32-bit integer to the stream in a big-endian byte order. More...
virtual bool | writeInt64 (int64 value)
| Writes a 64-bit integer to the stream in a little-endian byte order. More...
virtual bool | writeInt64BigEndian (int64 value)
| Writes a 64-bit integer to the stream in a big-endian byte order. More...
virtual bool | writeFloat (float value)
| Writes a 32-bit floating point value to the stream in a binary format. More...
virtual bool | writeFloatBigEndian (float value)
| Writes a 32-bit floating point value to the stream in a binary format. More...
virtual bool | writeDouble (double value)
| Writes a 64-bit floating point value to the stream in a binary format. More...
virtual bool | writeDoubleBigEndian (double value)
| Writes a 64-bit floating point value to the stream in a binary format. More...
virtual bool | writeRepeatedByte (uint8 byte, size_t numTimesToRepeat)
| Writes a byte to the output stream a given number of times. More...
virtual bool | writeCompressedInt (int value)
| Writes a condensed binary encoding of a 32-bit integer. More...
virtual bool | writeString (const String &text)
| Stores a string in the stream in a binary format. More...
virtual bool | writeText (const String &text, bool asUTF16, bool writeUTF16ByteOrderMark, const char *lineEndings)
| Writes a string of text to the stream. More...
virtual int64 | writeFromInputStream (InputStream &source, int64 maxNumBytesToWrite)
| Reads data from an input stream and writes it to this stream. More...
void | setNewLineString (const String &newLineString)
| Sets the string to write to the stream when a new line is written. More...
const String & | getNewLineString () const noexcept
| Returns the current new-line string that was set by setNewLineString(). More...

## Additional Inherited Members
Protected Member Functions inherited from OutputStream
| OutputStream ()

## Detailed Description

Used to write persistent ARA archives - see doStoreObjectsToStream() for details.

## Constructor & Destructor Documentation

## ◆ ARAOutputStream()

ARAOutputStream::ARAOutputStream | ( | ARA::PlugIn::HostArchiveWriter * |  | ) |
| explicit

## Member Function Documentation

## ◆ getPosition()

int64 ARAOutputStream::getPosition | ( |  | ) |
| overridevirtual

Returns the stream's current position.

See also
  setPosition

Implements OutputStream.

## ◆ flush()

void ARAOutputStream::flush | ( |  | ) |
| overridevirtual

If the stream is using a buffer, this will ensure it gets written out to the destination.

Implements OutputStream.

## ◆ write()

bool ARAOutputStream::write | ( | const void * | dataToWrite,
|  | size_t | numberOfBytes
| ) |  |
| overridevirtual

Writes a block of data to the stream.

When creating a subclass of OutputStream, this is the only write method that needs to be overloaded - the base class has methods for writing other types of data which use this to do the work.

Parameters

  dataToWrite | the target buffer to receive the data. This must not be null.
  numberOfBytes | the number of bytes to write.

Returns
  false if the write operation fails for some reason

Implements OutputStream.

## ◆ setPosition()

bool ARAOutputStream::setPosition | ( | int64 | newPosition | ) |
| overridevirtual

Tries to move the stream's output position.

Not all streams will be able to seek to a new position - this will return false if it fails to work.

See also
  getPosition

Implements OutputStream.

The documentation for this class was generated from the following file:

- juce_ARADocumentController.h